#-------------------------------------------------------------------------------
# Name:        grid_square_1
# Purpose: Перевод широты и долготы в Maidenhead систему
# Для написания кода использовалась информация по ссылке
# https://ham.stackexchange.com/questions/221/how-can-one-convert-from-lat-long-to-grid-square
# Author:      Yuri UB3FBR
# Created:     26.12.2017
#-------------------------------------------------------------------------------
def GRSQ(koord_str):
    upper = 'ABCDEFGHIJKLMNOPQRSTUVWX'
    lower = 'abcdefghijklmnopqrstuvwx'
    #koord_str = '55.164434, 37.435847' for UB3FBR QTH
    lat,long = koord_str.split (',')
    lat = lat.strip()
    long = long.strip()
    print ('Введенные данные')
    print ('Широта:' + lat)
    print ('Долгота:' + long)
    #Проверка корректности координат (Долгота -180...180, Широта -90...90)
    ch_long = float(long)
    ch_lat = float(lat)
    if ch_long>180 or ch_long <-180 or ch_lat>90 or ch_lat<-90:
        print ('Неправильные координаты')
        GRSQ_result = 'Error'
        return GRSQ_result
    # longitude Долгота
    ostatok = float(long) + 180
    Gr_long_sq = int(ostatok/20.0)
    ostatok = ostatok - Gr_long_sq*20
    Gr_long_n = int(ostatok/2.0)
    ostatok = ostatok - Gr_long_n*2.0
    Gr_long_subsq = int(ostatok*12)
    #latitude Широта
    ostatok = float(lat) + 90
    Gr_lat_sq = int(ostatok/10)
    ostatok = ostatok - Gr_lat_sq*10.0
    Gr_lat_n = int(ostatok)
    ostatok = ostatok - Gr_lat_n
    Gr_lat_subsq = int(ostatok*24.0)
    GRSQ_result = (upper[Gr_long_sq]+upper[Gr_lat_sq]+
                str(int(Gr_long_n))+str(int(Gr_lat_n))+
                lower[Gr_long_subsq]+lower[Gr_lat_subsq])
    return GRSQ_result

koord_str = input ('Введите Широту и Долготу через запятую: ')
GRSQrez = GRSQ(koord_str)
print('Grid Square: '+ GRSQrez)

